import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import java.util.ArrayList;

import org.apache.hadoop.io.DoubleWritable;
import org.apache.hadoop.io.Writable;

public class DoubleVectorWritable implements Writable {


	ArrayList<Double> v = new ArrayList<Double>();

	int k = 0;
	int type = 0;
	
	public DoubleVectorWritable() {}

	public DoubleVectorWritable(int k) {
		this.k=k;
	}

	public void setType(int i) {
		type = i;
	}

	public int getType() {
		return type;
	}

	public void addDouble(double d) {
		v.add(d);
	}

	public double getDouble(int index) {
		return v.get(index);
	}

	public void setDouble(int index, double d) {
		v.set(index, d);
	}

	@Override
	public void readFields(DataInput in) throws IOException {
		// TODO Auto-generated method stub
		type = in.readInt();
		for (int counter = 0; counter < k; counter++) {
			v.add(in.readDouble());
		}
	}

	public static DoubleVectorWritable read(DataInput in, int k)
			throws IOException {
		DoubleVectorWritable w = new DoubleVectorWritable(k);
		w.readFields(in);
		return w;
	}

	@Override
	public void write(DataOutput out) throws IOException {
		// TODO Auto-generated method stub
		out.writeInt(type);
		// new IntWritable(type).write(out);
		DoubleWritable dw = new DoubleWritable();
		for (int counter = 0; counter < v.size(); counter++) {
			out.writeDouble(v.get(counter));
		}
	}

}
