import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.Random;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FSDataOutputStream;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;


public class GenMatrix {

	public static void gen_hdfs(int m, int n, Path middledir, double sparse){
		try {
			System.out.println("generate matrix");
			FileSystem fs = middledir.getFileSystem(new Configuration());
			Path matrix = new Path(middledir, "matrix");
			FSDataOutputStream fd2 = fs.create(matrix);
			BufferedWriter fw=new BufferedWriter(new OutputStreamWriter(fd2));
			for (long i=1; i<=m; i++) {
				for (int j=1; j<=n; j++) {
					double value = new Random().nextDouble();
					fw.write(i + "\t" + j + "\t" + value + "\n");
				}
			}
			fw.flush();
			fw.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		
		if (args.length != 3) {
            System.err.println("Usage: GenMatrix <datadir> <m> <n>");
            System.exit(2);
        }
		
		String datadir = args[0];
	    
	    int m  = Integer.parseInt(args[1]);
	    int n  = Integer.parseInt(args[2]);
	    
	    Path datapath = new Path(datadir);
	    
	    gen_hdfs(m, n, datapath, 0);
	}
}
