import java.io.BufferedWriter;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.HashSet;
import java.util.Random;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FSDataOutputStream;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;

public class Initialize_randommatrix {
	
		public static void initW(int k, long n, long m, double range) throws IOException{
		System.out.println("Initializing W");
		DataOutputStream dos = new DataOutputStream(new FileOutputStream(new File("w_advance.dat")));
		FileWriter fw=new FileWriter(new File("w_advance.txt"));
		for (long i = 0; i < n; i++) {
			fw.write(i+1 + "\t");
			dos.writeLong(i+1);
			for (int j = 0; j< k; j++) {
				double value = new Random().nextDouble()*range;
				dos.writeDouble(value);
				fw.write(value + "") ;
				if (j!=k-1){
					fw.write(",");
				}else{
					fw.write("\n");
				}
				
			}
		}
		fw.flush();
		fw.close();
		dos.close();
		
	}
		
	public static void initH(int k, long n, long m,double range) throws IOException {
		System.out.println("Initializing H");
		DataOutputStream dos = new DataOutputStream(new FileOutputStream(new File("h_advance.dat")));
		FileWriter fw=new FileWriter(new File("h_advance.txt"));
		for (long i = 0; i < m; i++) {
			fw.write(i+1 + "\t");
			dos.writeLong(i+1);
			for (int j = 0; j< k; j++) {
				double value = new Random().nextDouble()*range;
				dos.writeDouble(value);
				fw.write(value + "") ;
				if (j!=k-1){
					fw.write(",");
				}else{
					fw.write("\n");
				}
			}
		}
		fw.flush();
		fw.close();
		dos.close();
	}
	
	public static void initW_hdfs(int k, long m, long n, double range, Path middledir, String mdir, int rp){
		try {
			System.out.println("Initializing W");
			FileSystem fs = middledir.getFileSystem(new Configuration());
			String mspath = middledir.toString() + "/wmatrix/0/output5/part-";
			Path[] msoutPath = new Path[rp];
			FSDataOutputStream[] msfd = new FSDataOutputStream[rp];
			BufferedWriter[] msfw = new BufferedWriter[rp];
			
			//Path file2 = new Path(middledir.toString() + "/wmatrix/0/output5/part-0.txt");
			//FSDataOutputStream fd2 = fs.create(file2);
			//BufferedWriter fw = new BufferedWriter(new OutputStreamWriter(fd2));
			
			FileSystem hdfs = middledir.getFileSystem(new Configuration());
			Path[] outPath = new Path[rp];
			FSDataOutputStream[] myfd = new FSDataOutputStream[rp];
			BufferedWriter[] myfw = new BufferedWriter[rp];
			
			for(int f=0; f<rp; f++)
			{
				msoutPath[f] = new Path(mspath + f);
				msfd[f] = fs.create(msoutPath[f]);
				msfw[f] = new BufferedWriter(new OutputStreamWriter(msfd[f]));
				
				outPath[f] = new Path(mdir + "/wmatrix/0/w" + f);
				myfd[f] = hdfs.create(outPath[f]);
				myfw[f] = new BufferedWriter(new OutputStreamWriter(myfd[f]));
			}
			
			int num = 0;
			if(m%rp == 0)
				num = (int) (m/rp);
			else
				num = (int) (m/rp + 1);
			
			int index = 0;
			for (long i = 0; i < m; i++) {
				
				index = (int) (i/num);
				msfw[index].write(i+1 + "\t");
				for (int j = 0; j< k; j++) {
					double value = new Random().nextDouble()*range;
					msfw[index].write(value + "") ;
					if (j!=k-1){
						msfw[index].write(",");
					}else{
						msfw[index].write("\n");
					}
					
					if (j!=k-1)
					{
						myfw[index].write(value+",");
					}
					else
					{
						myfw[index].write(value+"\n");
					}
				}
			}
			
			
			for(int f=0; f<rp; f++)
			{
				msfw[f].flush();
				msfw[f].close();
				msfd[f].close();
				
				myfw[f].flush();
				myfw[f].close();
				myfd[f].close();
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
		
	public static void initH_hdfs(int k, long m, long n, double range, Path middledir, String mdir, int cp){
		try {
			System.out.println("Initializing H");
			FileSystem fs = middledir.getFileSystem(new Configuration());
			String mspath = middledir.toString() + "/hmatrix/0/output5/part-";
			Path[] msoutPath = new Path[cp];
			FSDataOutputStream[] msfd = new FSDataOutputStream[cp];
			BufferedWriter[] msfw = new BufferedWriter[cp];
			
			FileSystem hdfs = middledir.getFileSystem(new Configuration());
			Path[] outPath = new Path[cp];
			FSDataOutputStream[] myfd = new FSDataOutputStream[cp];
			BufferedWriter[] myfw = new BufferedWriter[cp];
			
			for(int f=0; f<cp; f++)
			{
				msoutPath[f] = new Path(mspath + f);
				msfd[f] = fs.create(msoutPath[f]);
				msfw[f] = new BufferedWriter(new OutputStreamWriter(msfd[f]));
				
				outPath[f] = new Path(mdir + "/hmatrix/0/h" + f);
				myfd[f] = hdfs.create(outPath[f]);
				myfw[f] = new BufferedWriter(new OutputStreamWriter(myfd[f]));
			}
			
			int num = 0;
			if(n%cp == 0)
				num = (int) (n/cp);
			else
				num = (int) (n/cp + 1);
			
			int index = 0;
			for (long i = 0; i < n; i++) {
				
				index = (int) (i/num);
				msfw[index].write(i+1 + "\t");
				for (int j = 0; j< k; j++) {
					double value = new Random().nextDouble()*range;
					msfw[index].write(value + "") ;
					if (j!=k-1){
						msfw[index].write(",");
					}else{
						msfw[index].write("\n");
					}
					
					if (j!=k-1)
					{
						myfw[index].write(value+",");
					}
					else
					{
						myfw[index].write(value+"\n");
					}
				}
			}
			
			for(int f=0; f<cp; f++)
			{
				msfw[f].flush();
				msfw[f].close();
				msfd[f].close();
				
				myfw[f].flush();
				myfw[f].close();
				myfd[f].close();
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
		
	
	public static void randomMatrix( long n, long m, int range, long number) throws IOException {
		long probability=(long)(n*m/number*0.9);
		FileWriter fw=new FileWriter(new File(String.format("matrix1-%d-%d-%d.txt", n,m,number)));
		//int s[]=new int[probability];
		for (long i = 0; i < n; i++) {
			for (int j = 0; j< m; j++) {
				double randvalue=Math.abs(new Random().nextLong()% probability);
				if (randvalue==1){
					double value = new Random().nextDouble()*range;
					fw.write(i+1+"\t"+j+1+"\t"+value +"\n") ;
				}
				
			}
		}
		fw.flush();
		fw.close();
	}
	public static void randomMatrix_norepeat( long n, long m, int range, long size) throws IOException {
		FileWriter fw=new FileWriter(new File(String.format("matrix-%d-%d-%d.txt", n,m,size)));
	
		HashSet<long[]> set=new HashSet<long[]>();
		while (set.size()< size){
			Random rand=new Random();
			long[] line={Math.abs(rand.nextLong()%n),Math.abs(rand.nextLong()%m)};
			set.add(line);
			fw.write((line[0]+1)+"\t"+(line[1]+1)+"\t"+rand.nextDouble()*range+"\n");
		}
		
		fw.flush();
		fw.close();
	}
	
	void test(){
	}
	
	public static void main(String[] args) {
		
		try {
			int[][] list={{10000,10000},{100000,10000},{100000,100000},{1000000,100000}};
			for (int[] t: list)
			{randomMatrix_norepeat(t[0],t[1], 5, 1000000);
			}
			//randomMatrix_norepeat(n,m,5, 10000000);
		//	testH(path, "h1.dat", m);
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
