package auxstructure;
import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

import org.apache.hadoop.io.WritableComparable;

public class IntPair implements WritableComparable<IntPair> {
	private int first;
	private int second;
	
	public IntPair() {
		first = 0;
		second = 0;
	}
	
	public IntPair(int first, int second) {
		set(first, second);
	}
	
	public void set(int first, int second) {
		this.first = first;
		this.second = second;
	}
	
	public int getFirst() {
		return first;
	}
	
	public int getSecond() {
		return second;
	}
	
	@Override
	public void write(DataOutput out) throws IOException {
		out.writeInt(first);
		out.writeInt(second);
	}
	
	@Override
	public void readFields(DataInput in) throws IOException {
		first = in.readInt();
		second = in.readInt();
	}
	
	@Override
	public int hashCode() {
		return first * 100 + second;
	}
	
	@Override
	public boolean equals(Object o) {
		if (o instanceof IntPair) {
			IntPair tp = (IntPair) o;
			return first == tp.first && second == tp.second;
		}
		return false;
	}
	
	@Override
	public String toString() {
		return first + "\t" + second;
	}
	
	@Override
	public int compareTo(IntPair tp) {
		int cmp = first - tp.first;
		if (cmp != 0) {
			return cmp;
		}
		return second - tp.second;
		}

	public static int compare(int first1, int first2) {
		// TODO Auto-generated method stub
		int cmp = first1 - first2;
		return cmp;
	}
	}